%!TEX root = ../document.tex

\tikzstyle{input} = [draw, fill=none, rectangle, text width = 2.5cm,
                     align=center, minimum height = 1.5em]
\tikzstyle{value} = [draw, fill=none, rectangle, rounded corners,
                     text width = 2.5cm, align=center, minimum height = 1.5em]
\tikzstyle{strategy} = [draw, fill=none, rectangle, text width = 2cm,
                        align=center, rectangle]


\begin{tikzpicture}[auto,>=latex,node distance=0.25cm,line width=1pt,font=\scriptsize]
    
    % Input parameters
    \node [input, text width=1.5cm] (hardware) {Hardware};
    \node [input, right=of hardware, text width=2.75cm] (dictionary) {
    	Dictionary Variant
    	\vspace*{1.5em}
      \setlength{\leftmargini}{1.5em}
    	\begin{itemize}
         \addtolength{\itemsep}{-0.1cm}
    		\item Compr. Model
    		\item Time Extract\,/\,Str
    		\item Time Locate\,/\,Str
    		\item Time Construct\,/\,Str
		\end{itemize}
    };
    \node [input, right = of dictionary] (column) {
    	Column
      \setlength{\leftmargini}{1.5em}
    	\begin{itemize}
         \addtolength{\itemsep}{-0.1cm}
    		\item \# Extracts
    		\item \# Locates
    		\item Column Size
    		\item Construction frequency
    		\item Data
		\end{itemize}
    };
    \node [input, right = of column] (system) {
    	Database System
      \setlength{\leftmargini}{1.5em}
    	\begin{itemize}
         \addtolength{\itemsep}{-0.1cm}
    		\item Occupied Memory Size
    		\item Available Memory Size
		\end{itemize}
    };
    \node[fit=(dictionary)(hardware)(column)(system)](group){};
    
    % Intermediate result values
    \node [value,    node distance=0.5cm, below=of group] (size) {Dictionary Size};
    \node [value,    node distance=1cm, left=of size, text width=2.75cm] (runtime) {Runtime in Dictionary};
    \node [value,    node distance=1cm, right=of size] (goal) {Optimization Goal};
    \node [strategy, node distance=0.75cm, below=of size] (strategy) {Selection Strategy};
    
    % Group intermediate result values together
    \node[value, dashed, fit=(size)(runtime)](perdictionary){};
    \node[node distance=1em, below left=of perdictionary, anchor=west]{Per Dictionary Variant};
    
    \node[value, dashed, fit=(goal)](percolumn){};
    \node[node distance=1em, below right=of percolumn, anchor=east]{Per Column};
    
    % Connections (parameter -> intermediate value)
    \draw[->,dashed] (hardware)             --     (runtime);
    \draw[->]        (dictionary)           --     (runtime);
    \draw[->]        (dictionary)           --     (size);
    \draw[->]        (column.south west)               --     (runtime);
    \draw[->]        (column)               --     (size);
    \draw[->]        (column)               --     (goal);
    \draw[->]        (system)               --     (goal);
    
    % Connections (intermediate value -> Strategy)
    \draw[->]        (runtime)              --     (strategy);
    \draw[->]        (size)                 --     (strategy);
    \draw[->]        (goal)                 --     (strategy);
\end{tikzpicture}